/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.mirror.model;

import com.google.api.client.json.GenericJson;

/**
 * Represents media content, such as a photo, that can be attached to a timeline item.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Mirror API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Attachment extends GenericJson {

  /**
   * The MIME type of the attachment.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String contentType;

  /**
   * The URL for the content.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String contentUrl;

  /**
   * The ID of the attachment.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String id;

  /**
   * Indicates that the contentUrl is not available because the attachment content is still being
   * processed. If the caller wishes to retrieve the content, it should try again later.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean isProcessingContent;

  /**
   * The MIME type of the attachment.
   * The value returned may be {@code null}.
   */
  public String getContentType() {
    return contentType;
  }

  /**
   * The MIME type of the attachment.
   * The value set may be {@code null}.
   */
  public Attachment setContentType(String contentType) {
    this.contentType = contentType;
    return this;
  }

  /**
   * The URL for the content.
   * The value returned may be {@code null}.
   */
  public String getContentUrl() {
    return contentUrl;
  }

  /**
   * The URL for the content.
   * The value set may be {@code null}.
   */
  public Attachment setContentUrl(String contentUrl) {
    this.contentUrl = contentUrl;
    return this;
  }

  /**
   * The ID of the attachment.
   * The value returned may be {@code null}.
   */
  public String getId() {
    return id;
  }

  /**
   * The ID of the attachment.
   * The value set may be {@code null}.
   */
  public Attachment setId(String id) {
    this.id = id;
    return this;
  }

  /**
   * Indicates that the contentUrl is not available because the attachment content is still being
   * processed. If the caller wishes to retrieve the content, it should try again later.
   * The value returned may be {@code null}.
   */
  public Boolean getIsProcessingContent() {
    return isProcessingContent;
  }

  /**
   * Indicates that the contentUrl is not available because the attachment content is still being
   * processed. If the caller wishes to retrieve the content, it should try again later.
   * The value set may be {@code null}.
   */
  public Attachment setIsProcessingContent(Boolean isProcessingContent) {
    this.isProcessingContent = isProcessingContent;
    return this;
  }

}
