/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.mirror.model;

import com.google.api.client.json.GenericJson;

/**
 * A single value that is part of a MenuItem.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Mirror API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class MenuValue extends GenericJson {

  /**
   * The name to display for the menu item.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String displayName;

  /**
   * URL of an icon to display with the menu item.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String iconUrl;

  /**
   * The state that this value applies to. Allowed values are: - DEFAULT - Default value shown when
   * displayed in the menuItems list.  - PENDING - Value shown when the menuItem has been selected
   * by the user but can still be cancelled.  - CONFIRMED - Value shown when the menuItem has been
   * selected by the user and can no longer be cancelled.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String state;

  /**
   * The name to display for the menu item.
   * The value returned may be {@code null}.
   */
  public String getDisplayName() {
    return displayName;
  }

  /**
   * The name to display for the menu item.
   * The value set may be {@code null}.
   */
  public MenuValue setDisplayName(String displayName) {
    this.displayName = displayName;
    return this;
  }

  /**
   * URL of an icon to display with the menu item.
   * The value returned may be {@code null}.
   */
  public String getIconUrl() {
    return iconUrl;
  }

  /**
   * URL of an icon to display with the menu item.
   * The value set may be {@code null}.
   */
  public MenuValue setIconUrl(String iconUrl) {
    this.iconUrl = iconUrl;
    return this;
  }

  /**
   * The state that this value applies to. Allowed values are: - DEFAULT - Default value shown when
   * displayed in the menuItems list.  - PENDING - Value shown when the menuItem has been selected
   * by the user but can still be cancelled.  - CONFIRMED - Value shown when the menuItem has been
   * selected by the user and can no longer be cancelled.
   * The value returned may be {@code null}.
   */
  public String getState() {
    return state;
  }

  /**
   * The state that this value applies to. Allowed values are: - DEFAULT - Default value shown when
   * displayed in the menuItems list.  - PENDING - Value shown when the menuItem has been selected
   * by the user but can still be cancelled.  - CONFIRMED - Value shown when the menuItem has been
   * selected by the user and can no longer be cancelled.
   * The value set may be {@code null}.
   */
  public MenuValue setState(String state) {
    this.state = state;
    return this;
  }

}
